<?php

namespace Drupal\danse_log\Event;

use Drupal\danse_log\Payload;
use Symfony\Contracts\EventDispatcher\Event;

/**
 * Class LogEvent
 *
 * @package Drupal\danse_log\Event
 */
class LogEvent extends Event {

  /**
   * @var bool
   */
  protected $status = FALSE;

  /**
   * @var \Drupal\danse_log\Payload
   */
  protected $payload;

  /**
   * LogEvent constructor.
   *
   * @param \Drupal\danse_log\Payload $payload
   */
  public function __construct(Payload $payload) {
    $this->payload = $payload;
  }

  /**
   * Marks this event relevant.
   */
  public function setRelevant(): self {
    $this->status = TRUE;
    return $this;
  }

  /**
   * Marks this event irrelevant.
   */
  public function setIrrelevant(): self {
    $this->status = FALSE;
    return $this;
  }

  /**
   * @return bool
   */
  public function isRelevant(): bool {
    return $this->status;
  }

  /**
   * @return \Drupal\danse_log\Payload
   */
  public function getPayload(): Payload {
    return $this->payload;
  }

}
