<?php

namespace Drupal\danse_webhook\Plugin\Danse;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Url;
use Drupal\danse\Entity\EventInterface;
use Drupal\danse\PayloadInterface;
use Drupal\danse\PluginBase;
use Drupal\danse_webhook\Payload;

/**
 * Plugin implementation of DANSE.
 *
 * @Danse(
 *   id = "webhook",
 *   label = @Translation("Webhook"),
 *   description = @Translation("Provides a webhook to create events.")
 * )
 */
class Webhook extends PluginBase {

  /**
   * {@inheritdoc}
   */
  public function assertPayload(PayloadInterface $payload): bool {
    return $payload instanceof Payload;
  }

  /**
   * {@inheritdoc}
   */
  public function getSupportedSubscriptions($roles): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(&$form, FormStateInterface $form_state) {
    // TODO: Implement buildForm() method.
    return FALSE;
  }

  /**
   * {@inheritdoc}
   */
  public function getRedirectUrl(EventInterface $event): Url {
    return Url::fromRoute('<front>');
  }

  /**
   * @param string $agent
   * @param string $label
   * @param \Drupal\danse_webhook\Payload $payload
   *
   * @return \Drupal\danse\Entity\EventInterface|null
   */
  public function createWebhookEvent(string $agent, string $label, Payload $payload): ?EventInterface {
    return $this->createEvent($agent, $label, $payload);
  }

}
