<?php

namespace Drupal\danse\Entity;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\danse\PayloadInterface;
use Drupal\danse\PluginInterface;

/**
 * EventInterface.
 */
interface EventInterface extends ContentEntityInterface {

  /**
   * @return string
   */
  public function getPluginId(): string;

  /**
   * @return \Drupal\danse\PluginInterface
   */
  public function getPlugin(): PluginInterface;

  /**
   * @return \Drupal\danse\PayloadInterface|null
   */
  public function getPayload(): ?PayloadInterface;

  /**
   * @return string
   */
  public function getTopic(): string;

  /**
   * @return bool
   */
  public function isPush(): bool;

  /**
   * @return bool
   */
  public function isForce(): bool;

  /**
   * @return \Drupal\danse\Entity\EventInterface
   */
  public function setProcessed(): EventInterface;

}
