<?php

namespace Drupal\danse\Entity;

use Drupal\Core\Entity\ContentEntityInterface;

/**
 * NotificationInterface.
 */
interface NotificationInterface extends ContentEntityInterface {

  /**
   * @return int
   */
  public function uid(): int;

  /**
   * @return \Drupal\danse\Entity\EventInterface
   */
  public function event(): EventInterface;

  /**
   * @return \Drupal\danse\Entity\NotificationInterface
   */
  public function markSeen(): NotificationInterface;

  /**
   * @return \Drupal\danse\Entity\NotificationInterface
   */
  public function markDelivered(): NotificationInterface;

  /**
   * @param \Drupal\danse\Entity\NotificationInterface $notification
   *
   * @return \Drupal\danse\Entity\NotificationInterface
   */
  public function setSuccessor(NotificationInterface $notification): NotificationInterface;

}
