<?php

namespace Drupal\danse\Plugin\DanseRecipientSelection;

use Drupal\Component\Plugin\DerivativeInspectionInterface;
use Drupal\Component\Plugin\Exception\InvalidPluginDefinitionException;
use Drupal\Component\Plugin\Exception\PluginNotFoundException;
use Drupal\danse\PayloadInterface;
use Drupal\danse\RecipientSelectionBase;

/**
 * Plugin implementation of the DANSE role users recipient selection.
 *
 * @DanseRecipientSelection(
 *   id = "role",
 *   deriver = "Drupal\danse\Plugin\DanseRecipientSelection\RolesDeriver"
 * )
 */
class Roles extends RecipientSelectionBase implements DerivativeInspectionInterface {

  /**
   * {@inheritdoc}
   */
  public function getRecipients(PayloadInterface $payload): array {
    try {
      return $this->entityTypeManager->getStorage('user')->getQuery()
        ->condition('status', 1)
        ->condition('roles', $this->getPluginDefinition()['role'])
        ->execute();
    }
    catch (InvalidPluginDefinitionException $e) {
      // TODO: Handle exception.
    }
    catch (PluginNotFoundException $e) {
      // TODO: Handle exception.
    }
    return [];
  }

}
