<?php

namespace Drupal\danse_config;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\danse\Entity\Event;
use Drupal\node\Entity\Node;
use Drupal\danse\Entity\EventInterface;
use Drupal\danse\PayloadBase;
use Drupal\danse\PayloadInterface;

/**
 * Class Payload.
 *
 * @package Drupal\danse_config
 */
final class Payload extends PayloadBase {

  protected $object;

  /**
   * Content constructor.
   *
   * @param mixed $object
   */
  public function __construct($object = NULL) {
    $this->object = $object;
  }

  /**
   * {@inheritdoc}
   */
  public function label(Event $event): string {
    return 'config';
  }

  /**
   * {@inheritdoc}
   */
  public function getEventReference(): string {
    return '';
  }

  /**
   * {@inheritdoc}
   */
  public function getSubscriptionReferences(EventInterface $event): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function prepareArray(): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public static function createFromArray(array $payload): ?PayloadInterface {
    return new Payload();
  }

  /**
   * {@inheritdoc}
   */
  public function getEntity(): ContentEntityInterface {
    /** @var \Drupal\node\NodeInterface $entity */
    $entity = Node::create([
      'title' => 'not yet implemented',
    ]);
    return $entity;
  }

  /**
   * {@inheritdoc}
   */
  public function hasAccess($uid): bool {
    return FALSE;
  }

}
